/*
 * Character.cpp
 *
 *  Created on: 18/mar/2013
 *      Author: utente
 */

#include "Character.h"
#include "Weapon.h"
#include "Dice.h"
#include <iostream>

int Character::numChar = 0;

// the operator returns a reference to std::ostream so you can pipe it to other streams
std::ostream&  operator<<(std::ostream& os, Character& c) {
	os << "Char name: " << c.name << " - HP: " << c.HP << " - dexterity: " << c.dexterity << " - armor: " << c.armor;
	return os;
}

Character::Character(int hp, int a, int d) :
		name(""), HP(hp), dexterity(d), armor(a), weapon(0), posX(-1), posY(-1) {
	std::cout << "Non-playable character created" << std::endl;
	numChar++;
}

Character::Character(std::string n, int hp, int a, int d) :
		name(n), HP(hp), dexterity(d), armor(a), weapon(0), posX(-1), posY(-1) {
	std::cout << "Player character " << name << " created." << std::endl;
	numChar++;
}

int Character::fight(Character& enemy) {
	Dice dDice(4);
	int hit = dDice.throwDice() * dexterity;
	int damage = 0;
	if (hit > enemy.getDexterity()) {
		if (weapon == 0)
			return damage;
		damage = weapon->useWeapon();
		if (damage > enemy.getArmor()) {
			enemy.setHP(enemy.getHP() - damage);
			std::cout << "enemy hit: " << damage << std::endl;
		} else {
			std::cout << "did not pass through enemy armor !" << std::endl;
		}
	} else
		std::cout << "hit miss !" << std::endl;

	return damage;
}

void Character::move(int x, int y) {
	posX = x;
	posY = y;
	std::cout << "position: " << posX << " - " << posY << std::endl;
}
